pcl::Filter< PointT > Class Template Referenceabstract
Module filters

Filter represents the base filter class. More...

`#include <pcl/filters/filter.h>`

Inheritance diagram for pcl::Filter< PointT >:

## Public Types

typedef boost::shared_ptr< Filter< PointT > > | Ptr
typedef boost::shared_ptr< const Filter< PointT > > | ConstPtr
typedef pcl::PointCloud< PointT > | PointCloud
typedef PointCloud::Ptr | PointCloudPtr
typedef PointCloud::ConstPtr | PointCloudConstPtr
Public Types inherited from pcl::PCLBase< PointT >
typedef pcl::PointCloud< PointT > | PointCloud
typedef PointCloud::Ptr | PointCloudPtr
typedef PointCloud::ConstPtr | PointCloudConstPtr
typedef boost::shared_ptr< PointIndices > | PointIndicesPtr
typedef boost::shared_ptr< PointIndices const > | PointIndicesConstPtr

## Public Member Functions

| Filter (bool extract_removed_indices=false)
| Empty constructor. More...
virtual | ~Filter ()
| Empty destructor. More...
IndicesConstPtr const | getRemovedIndices ()
| Get the point indices being removed. More...
void | getRemovedIndices (PointIndices &pi)
| Get the point indices being removed. More...
void | filter (PointCloud &output)
| Calls the filtering method and returns the filtered dataset in output. More...
Public Member Functions inherited from pcl::PCLBase< PointT >
| PCLBase ()
| Empty constructor. More...
| PCLBase (const PCLBase &base)
| Copy constructor. More...
virtual | ~PCLBase ()
| Destructor. More...
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset. More...
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset. More...
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (size_t row_start, size_t col_start, size_t nb_rows, size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud. More...
IndicesPtr const | getIndices ()
| Get a pointer to the vector of indices used. More...
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used. More...
const PointT & | operator[] (size_t pos) const
| Override PointCloud operator[] to shorten code. More...

## Protected Member Functions

virtual void | applyFilter (PointCloud &output)=0
| Abstract filter method. More...
const std::string & | getClassName () const
| Get a string representation of the name of this class. More...
Protected Member Functions inherited from pcl::PCLBase< PointT >
bool | initCompute ()
| This method should get called before starting the actual computation. More...
bool | deinitCompute ()
| This method should get called after finishing the actual computation. More...

## Protected Attributes

IndicesPtr | removed_indices_
| Indices of the points that are removed. More...
std::string | filter_name_
| The filter name. More...
bool | extract_removed_indices_
| Set to true if we want to return the indices of the removed points. More...
Protected Attributes inherited from pcl::PCLBase< PointT >
PointCloudConstPtr | input_
| The input point cloud dataset. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
bool | use_indices_
| Set to true if point indices are used. More...
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud. More...

## Detailed Description

### template<typename PointT>
class pcl::Filter< PointT >

Filter represents the base filter class.

All filters must inherit from this interface.

Author
  Radu B. Rusu

Definition at line 83 of file filter.h.

## Member Typedef Documentation

template<typename PointT>

typedef boost::shared_ptr< const Filter<PointT> > pcl::Filter< PointT >::ConstPtr

Definition at line 90 of file filter.h.

template<typename PointT>

typedef pcl::PointCloud<PointT> pcl::Filter< PointT >::PointCloud

Definition at line 93 of file filter.h.

template<typename PointT>

typedef PointCloud::ConstPtr pcl::Filter< PointT >::PointCloudConstPtr

Definition at line 95 of file filter.h.

template<typename PointT>

typedef PointCloud::Ptr pcl::Filter< PointT >::PointCloudPtr

Definition at line 94 of file filter.h.

template<typename PointT>

typedef boost::shared_ptr< Filter<PointT> > pcl::Filter< PointT >::Ptr

Definition at line 89 of file filter.h.

## Constructor & Destructor Documentation

template<typename PointT>

pcl::Filter< PointT >::Filter | ( | bool | extract_removed_indices = `false` | ) |

inline

Empty constructor.

Parameters

  [in] | extract_removed_indices | set to true if the filtered data indices should be saved in a separate list. Default: false.

Definition at line 101 of file filter.h.

template<typename PointT>

virtual pcl::Filter< PointT >::~Filter | ( |  | ) |

inline virtual

Empty destructor.

Definition at line 109 of file filter.h.

## Member Function Documentation

template<typename PointT>

virtual void pcl::Filter< PointT >::applyFilter | ( | PointCloud & | output | ) |

protected pure virtual

Abstract filter method.

The implementation needs to set output.{points, width, height, is_dense}.

Parameters

  [out] | output | the resultant filtered point cloud

Implemented in pcl::ConditionalRemoval< PointT >, pcl::VoxelGridCovariance< PointT >, pcl::VoxelGridCovariance< PointTarget >, pcl::VoxelGrid< PointT >, pcl::VoxelGrid< PointTarget >, pcl::VoxelGrid< pcl::PointXYZRGBL >, pcl::ApproximateVoxelGrid< PointT >, pcl::FrustumCulling< PointT >, pcl::ModelOutlierRemoval< PointT >, pcl::PassThrough< PointT >, pcl::PassThrough< PointInT >, pcl::FilterIndices< PointT >, pcl::FilterIndices< PointInT >, pcl::FilterIndices< pcl::pcl::PCLPointCloud2 >, pcl::CropBox< PointT >, pcl::NormalSpaceSampling< PointT, NormalT >, pcl::StatisticalOutlierRemoval< PointT >, pcl::RadiusOutlierRemoval< PointT >, pcl::CovarianceSampling< PointT, PointNT >, pcl::ProjectInliers< PointT >, pcl::SamplingSurfaceNormal< PointT >, pcl::CropHull< PointT >, pcl::RandomSample< PointT >, pcl::RandomSample< pcl::pcl::PCLPointCloud2 >, pcl::ExtractIndices< PointT >, pcl::ShadowPoints< PointT, NormalT >, pcl::GridMinimum< PointT >, pcl::FastBilateralFilter< PointT >, pcl::MedianFilter< PointT >, pcl::LocalMaximum< PointT >, pcl::FastBilateralFilterOMP< PointT >, pcl::BilateralFilter< PointT >, and pcl::VoxelGridLabel.

Referenced by pcl::Filter< pcl::PointXYZRGBL >::filter().

template<typename PointT>

void pcl::Filter< PointT >::filter | ( | PointCloud & | output | ) |

inline

Calls the filtering method and returns the filtered dataset in output.

Parameters

  [out] | output | the resultant filtered point cloud dataset

Definition at line 131 of file filter.h.

Referenced by pcl::LocalMaximum< PointT >::applyFilterIndices(), pcl::SIFTKeypoint< PointInT, PointOutT >::detectKeypoints(), pcl::FilterIndices< pcl::pcl::PCLPointCloud2 >::filter(), pcl::FilterIndices< pcl::PCLPointCloud2 >::filter(), pcl::people::GroundBasedPeopleDetectionApp< PointT >::filter(), pcl::Filter< pcl::PCLPointCloud2 >::getRemovedIndices(), pcl::HypothesisVerification< ModelT, SceneT >::setSceneCloud(), pcl::ism::ImplicitShapeModelEstimation< FeatureSize, PointT, NormalT >::simplifyCloud(), and pcl::GlobalHypothesesVerification< ModelT, SceneT >::verify().

template<typename PointT>

const std::string& pcl::Filter< PointT >::getClassName | ( |  | ) | const

inline protected

Get a string representation of the name of this class.

Definition at line 176 of file filter.h.

Referenced by pcl::VoxelGridCovariance< PointTarget >::nearestKSearch(), pcl::VoxelGridCovariance< PointTarget >::radiusSearch(), and pcl::VoxelGridCovariance< PointTarget >::setMinPointPerVoxel().

template<typename PointT>

IndicesConstPtr const pcl::Filter< PointT >::getRemovedIndices | ( |  | ) |

inline

Get the point indices being removed.

Definition at line 113 of file filter.h.

template<typename PointT>

void pcl::Filter< PointT >::getRemovedIndices | ( | PointIndices & | pi | ) |

inline

Get the point indices being removed.

Parameters

  [out] | pi | the resultant point indices that have been removed

Definition at line 122 of file filter.h.

## Member Data Documentation

template<typename PointT>

bool pcl::Filter< PointT >::extract_removed_indices_

protected

Set to true if we want to return the indices of the removed points.

Definition at line 163 of file filter.h.

Referenced by pcl::FilterIndices< pcl::pcl::PCLPointCloud2 >::FilterIndices(), and pcl::FilterIndices< pcl::PCLPointCloud2 >::FilterIndices().

template<typename PointT>

std::string pcl::Filter< PointT >::filter_name_

protected

The filter name.

Definition at line 160 of file filter.h.

Referenced by pcl::CovarianceSampling< PointT, PointNT >::CovarianceSampling(), pcl::CropBox< PointT >::CropBox(), pcl::CropBox< pcl::PCLPointCloud2 >::CropBox(), pcl::CropHull< PointT >::CropHull(), pcl::ExtractIndices< PointT >::ExtractIndices(), pcl::ExtractIndices< pcl::PCLPointCloud2 >::ExtractIndices(), pcl::FrustumCulling< PointT >::FrustumCulling(), pcl::GridMinimum< PointT >::GridMinimum(), pcl::LocalMaximum< PointT >::LocalMaximum(), pcl::ModelOutlierRemoval< PointT >::ModelOutlierRemoval(), pcl::NormalSpaceSampling< PointT, NormalT >::NormalSpaceSampling(), pcl::PassThrough< PointInT >::PassThrough(), pcl::PassThrough< pcl::PCLPointCloud2 >::PassThrough(), pcl::ProjectInliers< PointT >::ProjectInliers(), pcl::ProjectInliers< pcl::PCLPointCloud2 >::ProjectInliers(), pcl::RadiusOutlierRemoval< PointT >::RadiusOutlierRemoval(), pcl::RadiusOutlierRemoval< pcl::PCLPointCloud2 >::RadiusOutlierRemoval(), pcl::RandomSample< pcl::pcl::PCLPointCloud2 >::RandomSample(), pcl::RandomSample< pcl::PCLPointCloud2 >::RandomSample(), pcl::SamplingSurfaceNormal< PointT >::SamplingSurfaceNormal(), pcl::ShadowPoints< PointT, NormalT >::ShadowPoints(), pcl::StatisticalOutlierRemoval< PointT >::StatisticalOutlierRemoval(), pcl::StatisticalOutlierRemoval< pcl::PCLPointCloud2 >::StatisticalOutlierRemoval(), pcl::VoxelGrid< pcl::PointXYZRGBL >::VoxelGrid(), pcl::VoxelGrid< pcl::PCLPointCloud2 >::VoxelGrid(), and pcl::VoxelGridCovariance< PointTarget >::VoxelGridCovariance().

template<typename PointT>

IndicesPtr pcl::Filter< PointT >::removed_indices_

protected

Indices of the points that are removed.

Definition at line 157 of file filter.h.

Referenced by pcl::Filter< pcl::PointXYZRGBL >::getRemovedIndices(), and pcl::Filter< pcl::PCLPointCloud2 >::getRemovedIndices().

The documentation for this class was generated from the following file:

- /build/pcl-0nnAvv/pcl-1.7.2/filters/include/pcl/filters/filter.h